
let cdbg1 = GetCurrentScriptDirectory~"cdbg1a.png";
let cdbg2 = GetCurrentScriptDirectory~"cdbg1b.png";
let stbg1 = GetCurrentScriptDirectory~"stg1bg.png";
let stbg2 = GetCurrentScriptDirectory~"stg1bg2.png";
let stbg3 = GetCurrentScriptDirectory~"stg1bg3.png";
let stbg4 = GetCurrentScriptDirectory~"stg1bg4.png";
let stgspeed = 5;
let SpellActive = false;

@Initialize{	
	Stage1Bg;
	SpellBG;
}
@MainLoop{
	let a = GetEnemyBossSceneObjectID;
	if(a != ID_INVALID && ObjEnemyBossScene_GetInfo(a, INFO_IS_SPELL)){
		SpellActive = true;
	}else{
		SpellActive = false;
	}
	yield;
}

task Stage1Bg{
	let StageBG1;
	let StageBG2;
	let StageBG3;
	let StageBGSky;
	let ypos = 0;
	let osize = 0;
	
	
	SetCameraFocusX(0);
	SetCameraFocusY(0);
	SetCameraFocusZ(100);
	SetCameraRadius(300);
	SetCameraElevationAngle(295);
	SetCameraAzimuthAngle(90);		
	
	StageBG1 = ObjPrim_Create(OBJ_SPRITE_3D);
	let bg1size = 256;
	ObjRender_SetBlendType(StageBG1, BLEND_ALPHA);
	ObjRender_SetAlpha(StageBG1, 255);
	ObjPrim_SetTexture(StageBG1, stbg1);
	ObjSprite3D_SetSourceRect(StageBG1, 0, ypos, bg1size*6, ypos+bg1size*6);
	ObjSprite3D_SetDestRect(StageBG1, -bg1size*2.5, 0, bg1size*2.5, bg1size*4);
	ObjRender_SetZWrite(StageBG1, true);
	ObjRender_SetZTest(StageBG1, true);
	
	
	StageBG2 = ObjPrim_Create(OBJ_SPRITE_3D);
	ObjRender_SetBlendType(StageBG2, BLEND_ALPHA);
	ObjRender_SetAlpha(StageBG2, 64);
	ObjPrim_SetTexture(StageBG2, stbg2);
	ObjSprite3D_SetSourceRect(StageBG2, 0, 0, bg1size*4, bg1size*4);
	ObjSprite3D_SetDestRect(StageBG2, -bg1size*2, -bg1size/2, bg1size*2, bg1size*4);
	ObjRender_SetZWrite(StageBG2, true);
	ObjRender_SetZTest(StageBG2, true);	
	
	StageBG3 = ObjPrim_Create(OBJ_SPRITE_3D);
	ObjRender_SetBlendType(StageBG3, BLEND_ALPHA);
	ObjRender_SetAlpha(StageBG3, 64);
	ObjPrim_SetTexture(StageBG3, stbg2);
	ObjSprite3D_SetSourceRect(StageBG3, 0, 0, bg1size*4, bg1size*4);
	ObjSprite3D_SetDestRect(StageBG3, -bg1size*2, -bg1size/2, bg1size*2, bg1size*4);
	ObjRender_SetZWrite(StageBG3, true);
	ObjRender_SetZTest(StageBG3, true);	
	
	StageBGSky = ObjPrim_Create(OBJ_SPRITE_3D);
	ObjRender_SetBlendType(StageBGSky, BLEND_ALPHA);
	ObjRender_SetAlpha(StageBGSky, 255);
	ObjPrim_SetTexture(StageBGSky, NULL);
	ObjSprite3D_SetSourceRect(StageBGSky, 0, 0, 0, 0);
	ObjSprite3D_SetDestRect(StageBGSky, -bg1size*2.5, 0, bg1size*2.5, bg1size*4);
	ObjRender_SetZWrite(StageBGSky, true);
	ObjRender_SetZTest(StageBGSky, true);
	
	
	ObjRender_SetPosition(StageBG1, 0, 0, -80);
	Obj_SetRenderPriority(StageBG1, 0.22);
	
	ObjRender_SetPosition(StageBG2, 0, 0, -75);
	ObjRender_SetAngleXYZ(StageBG2, 0, 0, 30);
	Obj_SetRenderPriority(StageBG2, 0.22);
	ObjRender_SetZTest(StageBG2, false);
	
	ObjRender_SetPosition(StageBG3, 0, 0, -75);
	ObjRender_SetAngleXYZ(StageBG3, 0, 0, 330);
	Obj_SetRenderPriority(StageBG3, 0.22);
	ObjRender_SetZTest(StageBG3, false);
	
	ObjRender_SetPosition(StageBGSky, 0, 700, -300);
	ObjRender_SetAngleXYZ(StageBGSky, 90, 0, 0);
	Obj_SetRenderPriority(StageBGSky, 0.22);
		
	SetFogEnable(true);
	SetFogParam(750, 1000, 144, 208, 255);
	CreateBrushGroupA1;
	yield;
	loop{		
		SetCameraFocusX(cos(osize)*75); // Remove these two lines
		SetCameraAzimuthAngle(sin(osize)*5+90);	// for static camera
		ObjSprite3D_SetSourceRect(StageBG1, 0, ypos, bg1size*6, ypos+bg1size*6);
		ObjSprite3D_SetSourceRect(StageBG2, ypos/2, 0, ypos/2+bg1size*4, bg1size*4);
		ObjSprite3D_SetSourceRect(StageBG3, -ypos/2, 0, -ypos/2+bg1size*4, bg1size*4);
		ypos+=stgspeed;
		osize += 1.5;
		if(ypos > 512){ypos = 0}
		if(osize >= 360){osize = 1;}
		yield;
	}
}


task SpellBG{
	let cdbg2X = 0;
	let fade = 0;
	
	let cdbg1Obj2 = CreateStaticBG(NULL, 0.23);
	ObjRender_SetColor(cdbg1Obj2, 96, 32, 16);
	let cdbg1Obj = CreateStaticBG(cdbg1, 0.24);
	
	let cdbg2Obj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(cdbg2Obj, BLEND_ALPHA);
	ObjRender_SetAlpha(cdbg2Obj, fade);
	ObjRender_SetX(cdbg2Obj, 0);
	Obj_SetRenderPriority(cdbg2Obj, 0.25);
	ObjPrim_SetTexture(cdbg2Obj, cdbg2);
	let rect = [GetStgFrameWidth, GetStgFrameHeight];
	ObjSprite2D_SetSourceRect(cdbg2Obj, 0, 0, rect[0], rect[1]);
	ObjSprite2D_SetDestRect(cdbg2Obj, -32, -32, rect[0]+32, rect[1]+32); //Stretched out a bit for screen shakes

	//By not setting a position for them, danmakufu places them at (0,0), which is 
	// what the current DestRect is accounting for.
	
	while(!IsCloseScript(GetScriptArgument("PluralID"))){
		if(SpellActive){
			fade = min(fade+12.75, 255);
		}else{fade=0;}
		
		if(cdbg2X>=512){cdbg2X = 0;}
		cdbg2X+=0.75;
		
		ObjSprite2D_SetSourceRect(cdbg2Obj, 0, cdbg2X, rect[0], rect[1]+cdbg2X);
		
		ObjRender_SetAlpha(cdbg1Obj, fade);
		ObjRender_SetAlpha(cdbg1Obj2, fade);
		ObjRender_SetAlpha(cdbg2Obj, fade/4);
		
		yield;
	}
	
	Obj_Delete(cdbg1Obj);
	Obj_Delete(cdbg1Obj2);
	Obj_Delete(cdbg2Obj);
	CloseScript(GetOwnScriptID);
	
	function CreateStaticBG(img, pri){
		let tempObj = ObjPrim_Create(OBJ_SPRITE_2D);
		ObjRender_SetBlendType(tempObj, BLEND_ALPHA);
		ObjRender_SetAlpha(tempObj, fade);
		Obj_SetRenderPriority(tempObj, pri);
		ObjPrim_SetTexture(tempObj, img);
		ObjSprite2D_SetSourceRect(tempObj, 0, 0, 384, 448);
		ObjSprite2D_SetDestRect(tempObj, -32, -32, 416, 480); //Stretched out a bit for screen shakes
		return tempObj;
	}
}

task CreateBrushGroupA1{
	let frame = 0;
	let frame2 = 0;
	let frequency = 2;
	let distance = 25;
	ascent(i in 0..1600){
		if(frame<=0){
			loop(frequency){
				CreateCloudA1(i);
			}
			frame = distance;
		}
		frame--;
	}

	loop{
		if(frame<=0){
			loop(frequency){
				CreateCloudA1(0);
			}
			frame = distance;
		}
		if(frame2<=0){
			CreateLeafA1;
			frame2 = 3; // Lower number for more, higher for less
		}
		frame--;
		frame2--;
		yield;
	}
}
task CreateCloudA1(begincloud){
	let cloud = Create3DBrush(255, 128, 128*round(rand(0,1)), stbg3, 0.23);
	let locpos = [rand(-450, 450), rand(1300,1600), 208];
	let alpha = 0;
	while(absolute(locpos[0]) < 128){ 
		locpos[0] = rand(-450, 450)
	}
	locpos[0] = locpos[0]-32;
	ObjRender_SetPosition(cloud, locpos[0], locpos[1], locpos[2]);
	ObjRender_SetAngleXYZ(cloud, 270, 90, 0);
	ObjRender_SetScaleXYZ(cloud, rand(0.6, 1), 2, 1);
	Obj_SetRenderPriority(cloud, 0.22);
	
	
	if(begincloud!=0){
		locpos[1] = locpos[1]-begincloud*4 - 200;
		alpha = 255;
	}
	
	while(locpos[1]>-32){
		locpos[1]=locpos[1]-stgspeed*1.25;
		alpha = min(alpha + 1, 255);
		ObjRender_SetAlpha(cloud, alpha);
		ObjRender_SetPosition(cloud, locpos[0], locpos[1], locpos[2]);
		yield;
	}
	while(alpha > 0){
		locpos[1]=locpos[1]-stgspeed*1.25;
		alpha = max(alpha - 6, 0);
		ObjRender_SetAlpha(cloud, alpha);
		ObjRender_SetPosition(cloud, locpos[0], locpos[1], locpos[2]);
		yield;
	}
	Obj_Delete(cloud);
}
task CreateLeafA1{
	let leaf = Create3DBrush(255, 32, 0, stbg4, 0.23);
	let locpos = [rand(-450, 450), rand(300,700), rand(128, 208)];
	let locang = [rand(0,360), rand(0,360), rand(0,360)];
	let locasp = [rand(-3, 3), rand(-3, 3), rand(-3, 3)];
	let alpha = 0;
	let etime = 140;
	locpos[0] = locpos[0]-32;
	ObjRender_SetPosition(leaf, locpos[0], locpos[1], locpos[2]);
	ObjRender_SetAngleXYZ(leaf, locang[0], locang[1], locang[2]);
	ObjRender_SetScaleXYZ(leaf, 0.5, 0.5, 0.5);
	Obj_SetRenderPriority(leaf, 0.22);
	
	while(etime > 0){
		etime--;
		alpha = min(alpha + 2, 128);
		UpdatePosition;
		yield;
	}
	while(alpha > 0){
		alpha = max(alpha - 2.5, 0);
		UpdatePosition;
		yield;
	}
	Obj_Delete(leaf);
	sub UpdatePosition{
		locpos[0]=locpos[0]-stgspeed/4;
		locpos[1]=locpos[1]-stgspeed/2;
		locpos[2]=locpos[2]-stgspeed/5;
		locang[0]=locang[0]+locasp[0];
		locang[1]=locang[1]+locasp[1];
		locang[2]=locang[2]+locasp[2];
		ObjRender_SetPosition(leaf, locpos[0], locpos[1], locpos[2]);
		ObjRender_SetAngleXYZ(leaf, locang[0], locang[1], locang[2]);
		ObjRender_SetAlpha(leaf, alpha);
	}
}

function Create3DBrush(alpha, srcrect, offset, image, priority){
	let StageProp = ObjPrim_Create(OBJ_SPRITE_3D);
	ObjRender_SetBlendType(StageProp, BLEND_ALPHA);
	ObjRender_SetAlpha(StageProp, alpha);
	ObjPrim_SetTexture(StageProp, image);
	Obj_SetRenderPriority(StageProp, priority);
	ObjSprite3D_SetSourceRect(StageProp, 0+offset, 0+offset, srcrect+offset, srcrect+offset);
	ObjSprite3D_SetDestRect(StageProp, 0, -srcrect/2, srcrect, srcrect/2); // Centered middle origin maybe
	//ObjRender_SetZWrite(StageProp, true);
	//ObjRender_SetZTest(StageProp, true);
	return StageProp;
}
function Create3DProperties(alpha, srcrect, image, priority){
	let StageProp = ObjPrim_Create(OBJ_SPRITE_3D);
	ObjRender_SetBlendType(StageProp, BLEND_ALPHA);
	ObjRender_SetAlpha(StageProp, alpha);
	ObjPrim_SetTexture(StageProp, image);
	Obj_SetRenderPriority(StageProp, priority);
	ObjSprite3D_SetSourceRect(StageProp, 0, 0, srcrect, srcrect);
	ObjSprite3D_SetDestRect(StageProp, -srcrect, -srcrect, srcrect, srcrect);
	ObjRender_SetZWrite(StageProp, true);
	ObjRender_SetZTest(StageProp, true);
	return StageProp;
}


